xquery version "3.0";

module namespace bird = "http://birdstrike";

import module namespace rest = "http://exquery.org/ns/restxq";
import module namespace xmldb = "http://exist-db.org/xquery/xmldb";
declare namespace output = "http://www.w3.org/2010/xslt-xquery-serialization";
declare namespace http = "http://expath.org/ns/http-client";


declare variable $bird:collection-path := "/db/demojam/data";


declare
    %rest:POST("{$birdstrike}")
    %rest:path("/birdstrike")
function bird:store($birdstrike) {
    let $db-uri := xmldb:store($bird:collection-path, (), $birdstrike),
    $id := doc($db-uri)/BirdStrike/@id return
        <rest:response>
            <http:response status="201">
                <http:header name="Location" value="{concat(rest:uri(), "/", $id)}"/>
            </http:response>
        </rest:response>
};

(: the pesky URI routing - not quite Zer0Translation... yet! :)

declare
    %rest:GET
    %rest:path("/birdstrike")
    %rest:produces("application/xml")
function bird:list-all() {
    bird:_list-all()
};

declare
    %rest:GET
    %rest:path("/birdstrike")
    %rest:produces("application/json")
    %output:method("json")
function bird:list-all-json() {
    bird:_list-all()
};

declare
    %rest:GET
    %rest:path("/birdstrike/{$id}")
    %rest:produces("application/xml")
function bird:birdstrike($id) {
    bird:_birdstrike($id)
};

declare
    %rest:GET
    %rest:path("/birdstrike/{$id}")
    %rest:produces("application/json")
    %output:method("json")
function bird:birdstrike-json($id) {
    bird:_birdstrike($id)
};



(: the business end :)

declare
    %private
function bird:_list-all() {
    <BirdStrikes>
    {
        for $birdstrike in collection($bird:collection-path)/BirdStrike return
            <BirdStrike id="{$birdstrike/@id}" uri="{xs:anyURI(concat(rest:uri(), "/", $birdstrike/@id))}">
            {
                $birdstrike/effect,
                $birdstrike/flight-date,
                $birdstrike/airport
            }
            </BirdStrike>
    }
    </BirdStrikes>
};

declare
    %private
function bird:_birdstrike($id) {
    let $birdstrike := collection($bird:collection-path)/BirdStrike[@id eq $id] return
        if($birdstrike) then
            $birdstrike
        else
            <rest:response>
                <http:response status="404"/>
            </rest:response>
};